#include <p18f45k20.h>
#include <stdio.h>
#include <math.h> 

#define LCD_DATA   	 PORTD
#define LCD_RS       PORTCbits.RC0
#define LCD_E        PORTCbits.RC1

void main (void);
void a2d_conversion(void);
void lcd_init(void);
void lcd_command(unsigned char);
void lcd_affiche(unsigned char);
void lcd_goto(unsigned char);
void lcd_delay(void);
void print_float(float);


#pragma code

/*************************
 * Definition des Variables
 *************************/

	float conversion;
	int U0; 	
	int U1;
	int prop;
	int integ;
	short int error0; 
	short int error1;
	unsigned char Ys;
	char Co;
	int M; 
	unsigned char kp;
	unsigned char ki;
	unsigned char delay;

/*********************
 * Fonction principal
 ********************/

void main()
{
	
 TRISD=0;
 ADCON1=0x00;
 ADCON0=0x01;
 ADCON2=0x80;

 error1=10;
 error0=0;

//*************************************************************************


/// display on LCD, kp= ( we entre the value using Keypad 4x4) and validate by '#'
/// display on LCD, ki= ( we entre the value using Keypad 4x4) and validate by '#'
/// display on LCD, Co= ( we entre the value using Keypad 4x4) and validate by '#'

//*************************************************************************

 lcd_init(); 
		lcd_affiche('Y');
		lcd_affiche('s');
		lcd_affiche('=');
	
while(1)
{

 ADCON0bits.GO = 1;

	while (ADCON0bits.GO)
		{
			//pas de opcode;		
		}

	Ys = ADRES;
	conversion=(5.0*(float)Ys)/1024.0;
 	lcd_goto(3);
 	print_float(conversion); 
 	lcd_delay();

	error0=Co-Ys;
 	M = error0 - error1;
 	prop = kp * M;	
	integ = ki * error0;			
	U0 =  U1 + prop + integ ;

}
}
/******************************************
 * Initialisation de lafficheur LCD 1x16
 ******************************************/

void lcd_init(void)
{
 TRISC=0;
 TRISD=0;
 lcd_command(0x30);		//accs 8 bits, 1 ligne de 16 C,
 lcd_command(0x01); 	//reset l'afficheur
 lcd_command(0x0C); 	//affichage ON - curseur ON 
 lcd_command(0x06); 	//deplacement du curseur vers la droite
}

/******************************************
 * configuration de lafficheur LCD 1x16
 ******************************************/

void lcd_command(unsigned char comand) 
{
  LCD_RS = 0;
  LCD_DATA = comand;
  LCD_E = 1;
  lcd_delay();
  LCD_E = 0;
}

/*********************
 * afficher sur LCD
 *********************/

void lcd_affiche(unsigned char affich) 
{
 LCD_RS = 1;
 LCD_DATA=affich;
 LCD_E = 1;
 lcd_delay();
 LCD_E = 0;
}

/*******************************
 * choisir une Position sur LCD
 *******************************/

void lcd_goto(unsigned char pos)
{
	TRISC = 0;
	TRISD = 0;	
	LCD_RS = 0;
	lcd_command(0x80+pos);
}

/*************************
 * Temporisation pour LCD
 *************************/

void lcd_delay(void)
{
int i=0;
for (i=0;i<250;i++);
}

/*******************************************
 * afficher le resultat en decimale sur LCD
 *******************************************/

void print_float(float n)

 { 
  int i,j; 
  i=(int)n%10;
  lcd_affiche(0x30|i); 
  lcd_affiche('.'); 
  for(j=0;j<2;j++)
   { 
  	 n*=10.0; 
   i=((int)(n))%10;
     lcd_affiche(0x30|i); 
   } 
 }
